> ## Documentation Index
> Fetch the complete documentation index at: https://docs.blnkfinance.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Pagination

> Navigate through large search result sets efficiently using page and per_page parameters

export const CtaCallout = props => {
  const {title, buttonLabel, href, trackingEvent, buttonTarget, rel = "noopener noreferrer", children} = props;
  const handleCtaClick = () => {
    if (typeof window === "undefined" || !trackingEvent) {
      return;
    }
    try {
      window.dispatchEvent(new CustomEvent("blnk:docs-cta", {
        detail: {
          name: trackingEvent,
          href
        }
      }));
    } catch {}
    try {
      window.posthog?.capture?.(trackingEvent, {
        href
      });
    } catch {}
    const gaPayload = {
      cta_href: href
    };
    try {
      window.gtag?.("event", trackingEvent, gaPayload);
    } catch {}
    try {
      window.dataLayer = window.dataLayer || [];
      window.dataLayer.push({
        event: trackingEvent,
        ...gaPayload
      });
    } catch {}
  };
  const isExternal = typeof href === "string" && (/^https?:\/\//i).test(href);
  const target = buttonTarget ?? (isExternal ? "_blank" : undefined);
  const linkRel = isExternal ? rel : undefined;
  return <section className="cta-callout not-prose relative my-8 w-full min-w-0 overflow-hidden rounded-xl border border-zinc-200 p-5 dark:border-white/10">
      <div className="cta-callout-noise" aria-hidden="true" />
      <div className="cta-callout-layout">
        {title ? <div className="cta-callout-title-row">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 28 28" width="14" height="14" className="cta-callout-icon shrink-0 text-zinc-800 dark:text-zinc-200" aria-hidden="true">
              <g fill="none" fillRule="nonzero">
                <path d="M28 0v28H0V0h28ZM14.691833333333335 27.134333333333334l-0.012833333333333334 0.0023333333333333335 -0.08283333333333333 0.04083333333333334 -0.023333333333333334 0.004666666666666667 -0.016333333333333335 -0.004666666666666667 -0.08283333333333333 -0.04083333333333334c-0.011666666666666667 -0.004666666666666667 -0.022166666666666668 -0.0011666666666666668 -0.028000000000000004 0.005833333333333334l-0.004666666666666667 0.011666666666666667 -0.019833333333333335 0.49933333333333335 0.005833333333333334 0.023333333333333334 0.011666666666666667 0.015166666666666667 0.12133333333333333 0.08633333333333333 0.0175 0.004666666666666667 0.014000000000000002 -0.004666666666666667 0.12133333333333333 -0.08633333333333333 0.014000000000000002 -0.018666666666666668 0.004666666666666667 -0.019833333333333335 -0.019833333333333335 -0.4981666666666667c-0.0023333333333333335 -0.011666666666666667 -0.0105 -0.019833333333333335 -0.019833333333333335 -0.021Zm0.3091666666666667 -0.13183333333333336 -0.015166666666666667 0.0023333333333333335 -0.21583333333333335 0.1085 -0.011666666666666667 0.011666666666666667 -0.0035000000000000005 0.012833333333333334 0.021 0.5016666666666667 0.005833333333333334 0.014000000000000002 0.009333333333333334 0.008166666666666668 0.23450000000000004 0.1085c0.014000000000000002 0.004666666666666667 0.026833333333333334 0 0.03383333333333334 -0.009333333333333334l0.004666666666666667 -0.016333333333333335 -0.03966666666666667 -0.7163333333333334c-0.0035000000000000005 -0.014000000000000002 -0.011666666666666667 -0.023333333333333334 -0.023333333333333334 -0.025666666666666667Zm-0.8341666666666667 0.0023333333333333335a0.026833333333333334 0.026833333333334334 0 0 0 -0.0315 0.007000000000000001l-0.007000000000000001 0.016333333333333335 -0.03966666666666667 0.7163333333333334c0 0.014000000000000002 0.008166666666666668 0.023333333333333334 0.019833333333333335 0.028000000000000004l0.0175 -0.0023333333333333335 0.23450000000000004 -0.1085 0.011666666666666667 -0.009333333333333334 0.004666666666666667 -0.012833333333333334 0.019833333333333335 -0.5016666666666667 -0.0035000000000000005 -0.014000000000000002 -0.011666666666666667 -0.011666666666666667 -0.21466666666666667 -0.10733333333333334Z" strokeWidth="1.1667" />
                <path fill="currentColor" d="M14 2.916666666666667A1.75 1.75 0 0 1 15.750000000000002 4.666666666666667v6.302333333333334L21.207666666666668 7.816666666666667a1.75 1.75 0 0 1 1.75 3.031L17.5 14l5.457666666666667 3.151166666666667a1.75 1.75 0 0 1 -1.75 3.031l-5.457666666666667 -3.1500000000000004V23.333333333333336a1.75 1.75 0 0 1 -3.5 0v-6.302333333333334L6.792333333333334 20.183333333333337a1.75 1.75 0 1 1 -1.75 -3.031L10.5 14 5.042333333333334 10.848833333333333a1.75 1.75 0 0 1 1.75 -3.031l5.457666666666667 3.1500000000000004V4.666666666666667A1.75 1.75 0 0 1 14 2.916666666666667Z" strokeWidth="1.1667" />
              </g>
            </svg>
            <p className="cta-callout-title min-w-0 font-semibold text-zinc-800 dark:text-zinc-200">
              {title}
            </p>
          </div> : null}
        <div className={`cta-callout-body text-sm leading-normal text-zinc-800 dark:text-zinc-200${title ? " cta-callout-body--indented" : ""}`}>
          {children}
        </div>
        <a href={href} target={target} rel={linkRel} onClick={handleCtaClick} data-docs-cta={trackingEvent || undefined} className="cta-callout-button inline-flex items-center justify-center gap-1 rounded-full bg-white px-3 py-1.5 text-sm font-semibold transition hover:bg-zinc-100 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-white/50 dark:bg-white dark:hover:bg-zinc-200">
          {buttonLabel}
          <span className="cta-callout-button-arrow" aria-hidden="true">
            →
          </span>
        </a>
      </div>
    </section>;
};

The `page` and `per_page` parameters control how search results are divided into manageable chunks. This is essential for handling large datasets efficiently and improving application performance.

***

## Quick start

Here's how to get the first 25 transactions:

<CodeGroup>
  ```bash cURL wrap theme={"system"}
  curl -X POST "http://YOUR_BLNK_INSTANCE_URL/search/transactions" \
    -H "X-Blnk-Key: YOUR_API_KEY" \
    -H "Content-Type: application/json" \
    -d '{
      "q": "*",
      "page": 1,
      "per_page": 25
    }'
  ```

  ```typescript TypeScript wrap theme={"system"}
  const response = await blnk.Search.search(
    {
      q: "*",
      page: 1,
      per_page: 25,
    },
    'transactions',
  );
  ```

  ```go Go wrap theme={"system"}
  results, resp, err := client.Search.SearchDocument(
    blnkgo.SearchParams{Q: "*", Page: 1, PerPage: 25},
    blnkgo.Transactions,
  )
  ```
</CodeGroup>

***

## Pagination parameters

| Parameter  | Description                                 | Default | Range/Limit    | Type      |
| :--------- | :------------------------------------------ | :------ | :------------- | :-------- |
| `page`     | Specifies which page of results to retrieve | `1`     | Minimum: `1`   | `integer` |
| `per_page` | Number of records returned in each page     | `10`    | Maximum: `250` | `integer` |

```bash theme={"system"}
# Examples
{
  "page": 1,        # First page (default)
  "per_page": 50    # 50 results per page
}

{
  "page": 3,        # Third page
  "per_page": 250   # Maximum results per page
}
```

***

## Common pagination patterns

<Steps>
  <Step title="Basic pagination">
    Start with the first page and a reasonable page size.

    <CodeGroup>
      ```bash cURL wrap theme={"system"}
      curl -X POST "http://YOUR_BLNK_INSTANCE_URL/search/transactions" \
        -H "X-Blnk-Key: YOUR_API_KEY" \
        -H "Content-Type: application/json" \
        -d '{
          "q": "*",
          "page": 1,
          "per_page": 50
        }'
      ```

      ```typescript TypeScript wrap theme={"system"}
      const response = await blnk.Search.search(
        {
          q: "*",
          page: 1,
          per_page: 50,
        },
        'transactions',
      );
      ```

      ```go Go wrap theme={"system"}
      results, resp, err := client.Search.SearchDocument(
        blnkgo.SearchParams{Q: "*", Page: 1, PerPage: 50},
        blnkgo.Transactions,
      )
      ```
    </CodeGroup>
  </Step>

  <Step title="Navigate to specific page">
    Jump to a specific page when you know the approximate location of your data.

    <CodeGroup>
      ```bash cURL wrap theme={"system"}
      curl -X POST "http://YOUR_BLNK_INSTANCE_URL/search/balances" \
        -H "X-Blnk-Key: YOUR_API_KEY" \
        -H "Content-Type: application/json" \
        -d '{
          "q": "*",
          "page": 5,
          "per_page": 100
        }'
      ```

      ```typescript TypeScript wrap theme={"system"}
      const response = await blnk.Search.search(
        {
          q: "*",
          page: 5,
          per_page: 100,
        },
        'balances',
      );
      ```

      ```go Go wrap theme={"system"}
      results, resp, err := client.Search.SearchDocument(
        blnkgo.SearchParams{Q: "*", Page: 5, PerPage: 100},
        blnkgo.Balances,
      )
      ```
    </CodeGroup>
  </Step>

  <Step title="Large result sets">
    Use maximum page size for bulk data processing.

    <CodeGroup>
      ```bash cURL wrap theme={"system"}
      curl -X POST "http://YOUR_BLNK_INSTANCE_URL/search/transactions" \
        -H "X-Blnk-Key: YOUR_API_KEY" \
        -H "Content-Type: application/json" \
        -d '{
          "q": "*",
          "filter_by": "created_at:[1720310400..1720396800]",
          "page": 1,
          "per_page": 250
        }'
      ```

      ```typescript TypeScript wrap theme={"system"}
      const response = await blnk.Search.search(
        {
          q: "*",
          filter_by: "created_at:[1720310400..1720396800]",
          page: 1,
          per_page: 250,
        },
        'transactions',
      );
      ```

      ```go Go wrap theme={"system"}
      results, resp, err := client.Search.SearchDocument(
        blnkgo.SearchParams{Q: "*", FilterBy: "created_at:[1720310400..1720396800]", Page: 1, PerPage: 250},
        blnkgo.Transactions,
      )
      ```
    </CodeGroup>
  </Step>

  <Step title="Combined with sorting">
    Paginate through sorted results for consistent ordering across pages.

    <CodeGroup>
      ```bash cURL wrap theme={"system"}
      curl -X POST "http://YOUR_BLNK_INSTANCE_URL/search/transactions" \
        -H "X-Blnk-Key: YOUR_API_KEY" \
        -H "Content-Type: application/json" \
        -d '{
          "q": "*",
          "sort_by": "created_at:desc",
          "page": 2,
          "per_page": 20
        }'
      ```

      ```typescript TypeScript wrap theme={"system"}
      const response = await blnk.Search.search(
        {
          q: "*",
          sort_by: "created_at:desc",
          page: 2,
          per_page: 20,
        },
        'transactions',
      );
      ```

      ```go Go wrap theme={"system"}
      results, resp, err := client.Search.SearchDocument(
        blnkgo.SearchParams{Q: "*", SortBy: "created_at:desc", Page: 2, PerPage: 20},
        blnkgo.Transactions,
      )
      ```
    </CodeGroup>
  </Step>
</Steps>

***

## Response structure

The pagination information is included in every search response:

```json theme={"system"}
{
  "found": 1247,
  "hits": [
    // ... result objects
  ],
  "out_of": 5000,
  "page": 2,
  "request_params": {
    "per_page": 50
  },
  "search_time_ms": 3
}
```

### Key response fields

| Field    | Description                                     | Type      |
| :------- | :---------------------------------------------- | :-------- |
| `found`  | Number of records matching your search criteria | `integer` |
| `out_of` | Total number of records in the collection       | `integer` |
| `page`   | Current page number                             | `integer` |
| `hits`   | Array of result objects for the current page    | `array`   |

***

## Best practices

* **Start with reasonable page sizes**: Use 20-50 records for UI display, 100-250 for data processing.
* **Always sort paginated results**: Use `sort_by` to ensure consistent ordering across pages.
* **Handle empty pages gracefully**: Check if `hits` array is empty before processing results.
* **Monitor performance**: Larger page sizes may impact response time.

***

## Need help?

We are very happy to help you make the most of Blnk, regardless of whether it is your first time or you are switching from another tool.

To ask questions or discuss issues, please [contact us](mailto:support@blnkfinance.com) or [join our Discord community](https://discord.gg/7WNv94zPpx).

<CtaCallout title="Connect your ledger to Blnk Cloud" href="https://cloud.blnkfinance.com/auth/sign-up?utm_source=blnk_docs&utm_medium=documentation&utm_campaign=need-help" buttonLabel="Open Blnk Cloud" trackingEvent="clicked_cloud_signup">
  Sign up and manage your ledger with our back-office dashboard. You can invite teammates to collaborate and manage your ledger operations directly from the dashboard.
</CtaCallout>
